#include <gdk/gdkkeysyms.h>
#include <pthread.h>
#ifdef BXZVT
#include "bxzvt.h"
#endif
#include "misc.h"
#include "window.h"
#include "server.h"
#include "hook.h"
#include "input.h"
#include "commands.h"
#include "gui.h"

GtkWidget	*mainwindow,
		*mainviewport,
		*mainmenubar,
		*mainscroller,
		*mainbox;
GdkFont		*mainfont;
GtkAdjustment	*mainadjust;
#ifndef BXZVT
char		mainansibuf[20];
#endif
int 		mainpipe[2];

/* Theses variables are used for interthread communication and 
   synchronization */
gint            gtkio;
int gtkipcin[2], guiipc[2], gtkcommandpipe[2];
pthread_t gtkthread;
pthread_mutex_t evmutex;
int gtk_duringwrite=0;
extern fd_set 	readables;

/* These are for $lastclickline() function */
char *lastclicklinedata = NULL;
int lastclickcol, lastclickrow;
int contextx, contexty;

/* Used by the scroller bars */
int newscrollerpos, lastscrollerpos, lastscrollerwindow;
unsigned long menucmd;

/* needed for rclick */
#include "keys.h"
void wm_process(int param);
unsigned long menucmd;   

/* This structure is used for passing commands to the gtk thread from the main thread */
int gtkincommand = FALSE, gtkthreadkill = FALSE;
typedef struct _gtkcommand {
	int		command;
	gpointer	data[10];
	} GtkCommand;
GtkCommand gtkcommand;

/* This is used in File Dialog to pass code to the main thread */
char *codeptr, *paramptr;

MenuStruct *findmenu(char *menuname);
int gtk_getx(void);
int gtk_gety(void);
void newmenubar(Screen *menuscreen, MenuStruct *menutoadd);
GtkWidget *newsubmenu(MenuStruct *menutoadd);
void gtk_new_window(Screen *new, Window *win);
void gtk_paste(char *args);
int gtkprintf(char *format, ...);

#define WIDTH	10

gushort bx_red[] = { 	0x0000, 0xbbbb, 0x0000, 0xaaaa, 0x0000, 0xbbbb, 0x0000, 0xaaaa, 0x7777, 
			0xffff, 0x0000, 0xeeee, 0x0000, 0xffff, 0x0000, 0xffff, 0xaaaa, 0x0000 };
gushort bx_green[] = { 	0x0000, 0x0000, 0xbbbb, 0xaaaa, 0x0000, 0x0000, 0xbbbb, 0xaaaa, 0x7777, 
			0x0000, 0xffff, 0xeeee, 0x0000, 0x0000, 0xeeee, 0xffff, 0xaaaa, 0x0000 };
gushort bx_blue[] = { 	0x0000, 0x0000, 0x0000, 0x0000, 0xcccc, 0xbbbb, 0xbbbb, 0xaaaa, 0x7777, 
			0x0000, 0x0000, 0x0000, 0xffff, 0xffff, 0xeeee, 0xffff, 0xaaaa, 0x0000};

GdkColor colors[] =
{
	{ 0, 0x0000, 0x0000, 0x0000 },	/* 0  black */
	{ 0, 0xbbbb, 0x0000, 0x0000 },	/* 1  red */
	{ 0, 0x0000, 0xbbbb, 0x0000 },	/* 2  green */
	{ 0, 0xaaaa, 0xaaaa, 0x0000 },	/* 3  yellow */
	{ 0, 0x0000, 0x0000, 0xcccc },	/* 4  blue */
	{ 0, 0xbbbb, 0x0000, 0xbbbb },	/* 5  magenta */
	{ 0, 0x0000, 0xbbbb, 0xbbbb },	/* 6  cyan */
	{ 0, 0xaaaa, 0xaaaa, 0xaaaa }, 	/* 7  white */
	{ 0, 0x7777, 0x7777, 0x7777 }, 	/* 8  grey */
	{ 0, 0xffff, 0x0000, 0x0000 },	/* 9  bright red */
	{ 0, 0x0000, 0xffff, 0x0000 },	/* 10 bright green */
	{ 0, 0xeeee, 0xeeee, 0x0000 },	/* 11 bright yellow */
	{ 0, 0x0000, 0x0000, 0xffff },	/* 12 bright blue */
	{ 0, 0xffff, 0x0000, 0xffff },	/* 13 bright magenta */
	{ 0, 0x0000, 0xeeee, 0xeeee },	/* 14 bright cyan */
	{ 0, 0xffff, 0xffff, 0xffff },	/* 15 bright white */
};

int tputs_x(char *blah)
{
	if(blah && *blah)
	{
		/*pthread_mutex_lock(&evmutex);
		tputs(buffer, 0, putchar_x);*/
		gtkprintf("%s", blah);
		/*pthread_mutex_unlock(&evmutex);*/
	}
return 0;
}

/* Find the screen of the Window that generated an event */
Screen *findscreen(GtkWidget *widget)
{
Screen *tmp;

	for(tmp = screen_list; tmp; tmp = tmp->next)
		{
		if(widget == tmp->window)
			return tmp;
		}
	return NULL;
}

Screen *findoutputscreen(int fd)
{
Screen *tmp;
	
	for(tmp = screen_list; tmp; tmp = tmp->next)
		{
		if(fd == tmp->pipe[0])
			return tmp;
		}
	return NULL;
}

void sendevent(char event, int window)
{
   char evbuf[2];

   if(guiipc[1])
      {
      evbuf[0] = event;
      evbuf[1] = (char) window;

      write(guiipc[1], evbuf, 2);
      }
  return;
}

/* Determine the most space the font will occupy, 
   fixed size fonts are recommended. */
void gtk_maxfont(Screen *thisscreen)
{
int z, cursize;
	
	thisscreen->maxfontwidth=0;
	for(z=0;z<256;z++)
		{
		cursize = gdk_char_width(thisscreen->font, (gchar)z);
		if(cursize > thisscreen->maxfontwidth)
			thisscreen->maxfontwidth = cursize;
		}
	thisscreen->maxfontheight=0;
	for(z=0;z<256;z++)
		{
		cursize = gdk_char_height(thisscreen->font, (gchar)z);
		if(cursize > thisscreen->maxfontheight)
			thisscreen->maxfontheight = cursize;
		}
}

/* This gets called when a window close event occurs, if it is the last
   active window, kill_screen will exit the application if WINDOW_CREATE
   is defined.  Otherwise it gets passed on to destroy.  */		
gint window_destroy(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef WINDOW_CREATE
Screen *closescreen;

	if((closescreen = findscreen(widget))!=NULL)
		{
		gtkthreadkill = TRUE;
		kill_screen(closescreen);
		gtkthreadkill = FALSE;
		}
	return TRUE;
#else 
	return FALSE;
#endif
}

/* This should not get called unless WINDOW_CREATE isn't defined */
void destroy(GtkWidget *widget, gpointer data)
{
	irc_exit(1, "gtkBitchX rocks your world!", NULL);
}

/* Wait for a command to be processed */
void gtk_wait_command(void)
{
	while(gtkincommand==TRUE)
		usleep(10);
}

/* Write a formatted string to the output_screen */
int gtkprintf(char *format, ...) 
{
va_list args;
char    putbuf[400];
      
	va_start(args, format);
	vsprintf(putbuf, format, args);
	va_end(args);
	
	write((output_screen && output_screen->pipe[1]) ? output_screen->pipe[1] : mainpipe[1], putbuf, strlen(putbuf));
	return strlen(putbuf);
}            
                                                                                                                                                                          
/* Write a character to the current output_screen */
int gtkputc(int c)
{
char tmpbuf[2];

   if((char)c == '\r')
   	return 1;
   tmpbuf[0] = (char)c; tmpbuf[1]=0;
   write((output_screen && output_screen->pipe[1]) ? output_screen->pipe[1] : mainpipe[1], tmpbuf, 1);
   return 1;
}

/* This gets called on a keypress event and writes it to the input queue */
gint gtk_keypress(GtkWidget *widget, GdkEventKey *event, gpointer data)
{
char extkeycode[4];

if(gtkipcin[1])
	{
	extkeycode[2] = 0;
	switch(event->keyval)
		{
		case GDK_Home:
			extkeycode[2] = '7';
			break;
		case GDK_End:
			extkeycode[2] = '8';
			break;
		case GDK_Page_Up:
			extkeycode[2] = '5';
			break;
		case GDK_Page_Down:
			extkeycode[2] = '6';
			break;
		case GDK_Insert:
			extkeycode[2] = '2';
			break;
		case GDK_Delete:
			extkeycode[2] = '3';
			break;
		case GDK_Up:
			extkeycode[2] = 'A';
			break;
		case GDK_Down:
			extkeycode[2] = 'B';
			break;
		case GDK_Left:
			extkeycode[2] = 'D';
			break;
		case GDK_Right:
			extkeycode[2] = 'C';
			break; 
		}
	if(extkeycode[2] != 0)
		{
		extkeycode[0] = 27;
		extkeycode[1] = '[';
		extkeycode[3] = '~';
		if(event->keyval >= GDK_Left && event->keyval <= GDK_Down)
			write(gtkipcin[1], extkeycode, 3);
		else
			write(gtkipcin[1], extkeycode, 4);
		return TRUE;
		}
	write(gtkipcin[1], event->string, strlen(event->string));
	}
return TRUE;
}

#ifndef BXZVT
/* Clears the gtk text presentation space */
void gtk_clrscr(Screen *clrscreen)
{
int len;

len=gtk_text_get_length(GTK_TEXT(clrscreen ? clrscreen->viewport : mainviewport));
gtk_text_set_point(GTK_TEXT(clrscreen ? clrscreen->viewport : mainviewport), 0);
gtk_text_forward_delete(GTK_TEXT(clrscreen ? clrscreen->viewport : mainviewport), len);
}

/* gtk Clear End of Line */
void gtk_clreol(void)
{
int pos, len, z;

pos = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
len = gtk_text_get_length(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

z=0;
while((z+pos-1)<len)
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z+pos)=='\n')
		break;
	z++;
	}
if(z-1 > 0)
	gtk_text_forward_delete(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z-1);
}
		
/* Position the write position at a x - y coordinate */
void gtk_gotoxy(int x, int y)
{
int cx=0, cy=0, z, len, t;

if(x<0 || y<0)
	return;
	
len = gtk_text_get_length(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
for(z=0;z<len;z++)
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z) == '\n')
		{
		if(cy != y)
			cx=0;
		cy++;
		}
	else
		cx++;
	if((cx == x && cy == y) || cy > y)
		break;
	}
	
if(cy < y)
	{
	gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z);
	for(t=0;t<(y-cy);t++)
		gtk_text_insert(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), output_screen ? output_screen->font : mainfont, &colors[WHITE], &colors[BLACK], "\n", 1);
	z=z+t;
	len=gtk_text_get_length(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
	/*z=z+t-1*/
	cx=0;
	}

if(z<len)	
	gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z+1);
	
if(cx < x)
	{
	for(t=0;t<(x-cx);t++)
		gtk_text_insert(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), output_screen ? output_screen->font : mainfont, &colors[WHITE], &colors[BLACK], " ", 1);
	}
}

/* Move the current write position back n characters */
void gtk_backward(int n)
{
int pos, k=0;

pos = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
if(n>pos)
	n=pos;
while(pos>-1 && k<n)
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), pos)=='\n')
		{
		pos++;
		break;
		}
	pos--;
	k++;
	}
gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), pos);
}

/* Move the current write position forward n characters */
void gtk_forward(int n)
{
int pos, z, k, j, len;

pos = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
len = gtk_text_get_length(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

z=0;k=0;
while((z+pos)<len)
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z+pos)=='\n')
		{
		z--;k--;
		break;
		}
	z++;
	k++;
	}
gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z+pos);
if(k<n)
	{
	for(j=0;j<n-k;j++)
		gtk_text_insert(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), output_screen ? output_screen->font : mainfont, &colors[WHITE], &colors[BLACK], " ", 1);
	}	
}

/* Emulate a char 8 backspace character */
void gtk_backspace(void)
{
int pos;

pos = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

if(pos > 0 && GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), pos-1)!='\n')
	{
	gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), pos-1);
	gtk_text_forward_delete(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), 1);
	gtk_text_insert(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), output_screen ? output_screen->font : mainfont, &colors[WHITE], &colors[BLACK], " ", 1);
	gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), pos);
	}
}

/* Scroll the gtk text between top and bot n lines. */
void gtk_scroll(int top, int bot, int n)
{
int z, len, chars=0, position=0, lines=0, dellines=0;

len=gtk_text_get_length(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

gtk_text_freeze(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

while(position < len && lines < top)
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), position)=='\n')
		lines++;
	position++;
	}
if(lines == top)
	{
	gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), position);
	while(position < len && dellines < n)
		{
		if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), position)=='\n')
			dellines++;
		position++;
		chars++;
		}
	gtk_text_forward_delete(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), chars);
	}
dellines=0;
len = gtk_text_get_length(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
position = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
while(position < len && dellines < (bot-top-n+1))
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), position) == '\n')
		dellines++;
	position++;
	}
gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), position);
for(z=0;z<n;z++)
	gtk_text_insert(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), output_screen ? output_screen->font : mainfont, &colors[WHITE], &colors[BLACK], "\n", 1);

gtk_text_thaw(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
}

/* Get the current line of the write position */
int gtk_gety(void)
{
int z, pos, curline=0;

pos = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

for(z=0; z<pos; z++)
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z)=='\n')
		curline++;
	}
return curline;
}

/* Get the current column of the write position */
int gtk_getx(void)
{
int z, pos, curcol=0;

pos = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

for(z=pos-1;z>-1;z--)
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z)=='\n')
		break;
	curcol++;
	}
return curcol;
}

/* If any lines are wider than the physical space add newlines */
void gtk_fixnewlines(void)
{
int len, curx=0, pos, z;

len = gtk_text_get_length(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
pos = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

for(z=0;z<len;z++)
	{
	if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z)=='\n')
		curx=-1;
	if(curx ==  (output_screen ? output_screen->co : 25))
		{
		gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z);
		gtk_text_insert(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), output_screen ? output_screen->font : mainfont, output_screen ? &colors[output_screen->fg] : &colors[WHITE], output_screen ? &colors[output_screen->bg] : &colors[BLACK], "\n", 1);
		len++;
		if(z<pos)
			pos++;
		curx=-1;
		}
	curx++;
	}
gtk_text_set_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), pos);	
}

/* Write text to the gtk presentation space */
void gtk_write(char *buffer, int t)
{   
int z, pos, len, chars=0, lines=0, curline=0, curchar=0;

	pos = gtk_text_get_point(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
	len = gtk_text_get_length(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
	
	/* Count the number of lines/chars to add */
	for(z=0;z<t;z++)
		{
		chars++;
		if(buffer[z] == '\n')
			{
			lines++;
			chars=0;
			}
		}

	curline = gtk_gety();
	
	/* If we are going to scroll off the physical viewport, delete the
	   necessary lines from the top of the viewport to scroll up. */
	
	/*if(curline+lines > (output_screen ? output_screen->li : 25))
		gtk_scroll(0, (output_screen ? output_screen->li : 25), (curline+lines) - (output_screen ? output_screen->li : 24));*/
	
	/* Determine number of chars to delete */
	z=0;curline=0;
	while(curline < lines && (pos+z) < len)
		{
		if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), pos+z)=='\n')
			curline++;
		z++;
		}
	if(curline == lines && chars > 0)
		{
		while(curchar<chars && (z+pos) < len)
			{
			if(GTK_TEXT_INDEX(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport),pos+z) == '\n')
				{
				z--;
				break;
				}
			z++;
			curchar++;
			}
		}
        	gtk_text_freeze(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
		if(z>0)
			gtk_text_forward_delete(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), z);
		gtk_text_insert(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport), output_screen ? output_screen->font : mainfont, output_screen ? &colors[output_screen->fg] : &colors[WHITE], output_screen ? &colors[output_screen->bg] : &colors[BLACK], buffer, t);
		gtk_text_thaw(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));

	gtk_fixnewlines();
}
#endif

/* This is the main output function, code will need to be added here to make
   sure text goes to the correct window as well as ANSI handling etc, this 
   will probably be the most complex part of gtkBitchX */

void output_info(gpointer data, int pipefd)
{
char buffer[201];
int t;
Screen *os;
#ifndef BXZVT
char def[20], buffer2[210]; /* It really should't ever go above 200 ... but just to be safe :) */
int x=0, z=0, escape=-1, m, cstart, bright;
int params[10], nparams;
#endif
 
	t = read(pipefd, buffer, 200);
	buffer[t] = 0;

	os = findoutputscreen(pipefd);
#ifndef BXZVT
        if(!output_screen)
        	{
        	/*gtk_write(buffer, t);*/
        	return;
        	}
        	
        if(output_screen->ansibuf && *output_screen->ansibuf) /* There was a partial sequence from last time, add it to the subbuffer */
        	{
        	x = strlen(output_screen->ansibuf);
        	memcpy(buffer2, output_screen->ansibuf, x);
        	escape = 0;
        	}
        /* We are in an escape sequence but no info has been saved */
        if(output_screen->escape == 1 && escape == -1)
        	escape = 0;
        for(z=0;z<t;z++)
        	{
        	if(escape > -1) /* We are in an escape sequence, see if we have all of it */
        		{   	/* if not we will save what we have and proceed next time */
        		buffer2[x]=buffer[z];
        		/* We've got a complete ANSI sequence */
        		if((buffer2[x] >= 'a' && buffer2[x] <= 'z') || (buffer2[x] >= 'A' && buffer2[x] <= 'Z'))
        			{
       				cstart=1; 
        			nparams=0;
        			buffer2[x+1]=0;
        			strcpy(def, buffer2);
        			/*printf("ANSI Sequence: %s\n", def);*/
        			params[0]=params[1]=-1;
        			for(m=1;m<(x+1);m++)
        				{
        				if(buffer2[m]==';' || m == x || buffer2[m] == ':')
        					{
        					buffer2[m]=0;
        					if(strlen(&buffer2[cstart])>0)
        						params[nparams]=atoi(&buffer2[cstart]);
        					nparams++;
        					cstart=m+1;
        					}
        				}
        			strcpy(buffer2, def);
        			gtk_text_freeze(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
               			switch(buffer2[x]) /* Here is the miserable ANSI interpretting code :) */
        				{
 
        			  	case 'm': /* Color change sequence */
        			  	cstart=1;
        			  	for(m=0;m<nparams;m++)
        			  		{
        			  		/* Reset colors */
        			  		if(params[m] == 0)
        			  			{
        			  			output_screen->fg = WHITE;
        			  			output_screen->bg = BLACK;
        			  			}
        			  		/* Set bright attribute */
        			  		if(params[m] == 1 && output_screen->fg < 8)
        			  			output_screen->fg += 8;
        			 
        			 		/* Foreground color */
        			  		if(params[m] > 29 && params[m] < 38)
        			  			{
        			  			/* Check current bright state */
        			  			if(output_screen->fg > 7)
        			  				bright = 1;
        			  			else
        			  				bright = 0;
        			  					
        			  			output_screen->fg = params[m] - 30;
        			  			
        			  			/* If bright is on increment the foreground color */ 
        			  			if(bright == 1)
        			  				output_screen->fg += 8;
        			  			}
        			  			
        			  		/* Background color */
        			  		if(params[m] > 39 && params[m] < 48)
        			  			output_screen->bg = params[m] - 40;
        			  		}
        			  	break;
        			  	case 'C': /* Cursor Forward */
        			  	if(nparams == 1)
        			  		gtk_forward(params[0]);
        			  	else
        			  		gtk_forward(1);
        			  	break;
        			  	case 'D': /* Cursor Backward */
        			  	if(nparams == 1)
        			  		gtk_backward(params[0]);
        			  	else
        			  		gtk_backward(1);
        			  	break;
        			  	case 'J': /* Clear Screen */
        			  	if(nparams == 1 && params[0]==2)
        			  		gtk_clrscr(output_screen);
        			  	break;
        			  	case 'K':
        			  	gtk_clreol();
        			  	break;
        			  	case 'H': /* Cursor Goto xy */
        			   	params[0]--;params[1]--;
        			   	if(nparams == 0)
        			   		gtk_clrscr(output_screen);
        			   	else
        			  		gtk_gotoxy(params[1], params[0]);
        			  	break;
        			  	case 'N':
        			  	if(nparams == 3)
        			  		gtk_scroll(params[0], params[1], params[2]);
        			  	}
        			gtk_text_thaw(GTK_TEXT(output_screen ? output_screen->viewport : mainviewport));
        			/* Escape sequence has been processed, reset subbuffer and escape flag */
        			output_screen->escape = 0;
        			escape = -1;
        			x=-1;
        			}
        		x++;
        		}
        	else
        		{
        		if(buffer[z] != '\e') /* No Escape sequence, continue normally */
        			{
        			/* Handle the backspace */
        			if(buffer[z] == 8)
        				gtk_backspace();
        			else
        				{
        				buffer2[x] = buffer[z];
        				x++;
        				}
        			}
        		else	/* We have an escape sequence, write what we have in the buffer before reading it */
        			{
        			if(x!=0)
        				{
        				gtk_write(buffer2, x);
        				x=0;
        				}
        			output_screen->escape = 1;
        			escape=z;
        			}
        		}	
        	}
	if(x>0 && escape > -1 && x < 20) /* Save the partial sequence for next entry */
		{
		memcpy(output_screen->ansibuf, buffer2, x);
		output_screen->ansibuf[x] = 0;
		}
	else 
		output_screen->ansibuf[0] = 0;
	if(x>0 && escape == -1) /* Write the remaining text to the viewport */
		gtk_write(buffer2, x);
#else
        if(os && os->viewport)
             zvt_term_feed((ZvtTerm *)os->viewport, buffer, t);
        else
             zvt_term_feed((ZvtTerm *)mainviewport, buffer, t);
#endif
}

/* This function sets the window size to the current columns and rows */
void gtk_sizewindow(Screen *thisscreen)
{
#ifndef BXZVT
gtk_widget_set_usize(thisscreen->viewport, (thisscreen->maxfontwidth * (thisscreen->co))+14, (thisscreen->maxfontheight * thisscreen->li)+8);
#else
zvt_term_set_size((ZvtTerm *)thisscreen->viewport, thisscreen->co, thisscreen->li);
#endif 
}

/* This may be going away, it replaces code which is currently elsewhere in BitchX */
void gtk_resize(Screen *this_screen)
{
        co = this_screen->co; li = this_screen->li;
             
        /* Recalculate some stuff that was done in input.c previously */
        this_screen->input_line = this_screen->li-1;
        
        this_screen->input_zone_len = this_screen->co - (WIDTH * 2);
	if (this_screen->input_zone_len < 10)
             	this_screen->input_zone_len = 10;             /* Take that! */                           
             
        this_screen->input_start_zone = WIDTH;
        this_screen->input_end_zone = this_screen->co - WIDTH;
}                  

/* This gets called when the window size event occurs */
void gtk_windowsize(GtkWidget *widget, gpointer data)
{
Screen *sizescreen;
	
	if((sizescreen = findscreen(widget))!= NULL && sizescreen->maxfontwidth > 0 && sizescreen->maxfontwidth > 0)
		{
#ifdef BXZVT
		sizescreen->co = (int) ((sizescreen->viewport->allocation.width) / sizescreen->maxfontwidth);
		sizescreen->li = (int) ((sizescreen->viewport->allocation.height) / sizescreen->maxfontheight);
#else
		sizescreen->co = (int) ((sizescreen->viewport->allocation.width-15) / sizescreen->maxfontwidth);
		sizescreen->li = (int) ((sizescreen->viewport->allocation.height-7) / sizescreen->maxfontheight);
#endif
		gtk_sizewindow(sizescreen);
		gtk_resize(sizescreen);
		recalculate_windows(sizescreen);
		/* Send the resize message to the main thread */
		sendevent(EVREFRESH, last_input_screen->current_window->refnum);
		}
}

/* This gets called when a window gets the focus */
void gtk_windowfocus(GtkWidget *widget, gpointer *data)
{
Screen *focusscreen;

	if((focusscreen = findscreen(widget))!=NULL && focusscreen->current_window)
	sendevent(EVFOCUS, focusscreen->current_window->refnum);
}

/* This gets called when the scroller bar gets moved on a window */
void gtk_scrollerchanged(GtkWidget *widget, GtkWidget *window)
{
Screen *thisscreen;

	if((thisscreen = findscreen(window))!=NULL)
		{
		newscrollerpos=thisscreen->adjust->value - 1;
		if(newscrollerpos<0)
			newscrollerpos=0;
		if(newscrollerpos>get_int_var(SCROLLBACK_VAR))
			newscrollerpos=get_int_var(SCROLLBACK_VAR);
		sendevent(EVSTRACK, thisscreen->current_window->refnum);
		}
}

/* This handles right click events on the viewport */
void gtk_contextmenu(GtkWidget *widget, GdkEventButton *event, GtkWidget *window)
{
Screen *this_screen;
int statusstart;
#ifdef BXZVT
char *zvt_buffer;
#endif

if((this_screen = findscreen(window))!=NULL)
        {
            if(event->button == 3)
                {
		/* This will only give decent results with fixed width fonts at the moment */
		lastclickrow = (int)(event->y/this_screen->maxfontheight);
		lastclickcol = (int)(event->x/this_screen->maxfontwidth);
		
		last_input_screen=output_screen=this_screen;
		make_window_current(this_screen->current_window);
		statusstart=this_screen->li - 2;
		
#ifdef BXZVT
		zvt_buffer = zvt_term_get_buffer((ZvtTerm *)this_screen->viewport, NULL, VT_SELTYPE_LINE, 0, lastclickrow+1, 0, lastclickrow);
		if(zvt_buffer && *zvt_buffer)
			{
			strcpy(lastclicklinedata, zvt_buffer);
			free(zvt_buffer);
			}
		else
#endif
			strcpy(lastclicklinedata, "");
		 
		if(this_screen->window_list_end->status_lines == 0 && this_screen->window_list_end->double_status == 1 && this_screen->window_list_end->status_split == 1)
			statusstart=statusstart-1;
		if(this_screen->window_list_end->status_lines == 1 && this_screen->window_list_end->double_status == 0 && this_screen->window_list_end->status_split == 0)
			statusstart=statusstart-1;
		if(this_screen->window_list_end->status_lines == 1 && this_screen->window_list_end->double_status == 1 && this_screen->window_list_end->status_split == 1)
			statusstart=statusstart-1;
		if(this_screen->window_list_end->status_lines == 1 && this_screen->window_list_end->double_status == 1 && this_screen->window_list_end->status_split == 0)
			statusstart=statusstart-2;
		if(lastclickrow <= (current_window->screen->li - 2) && lastclickrow >= statusstart)		
			wm_process(STATUSRCLICK);
		else
			wm_process(RCLICK);

                } else if (event->button == 2) {
#ifdef BXZVT
                    GtkWidget *edittmp;
                    char *texttmp;
                    int len;
            
                    edittmp = gtk_text_new(NULL, NULL);
                    gtk_text_set_editable(GTK_TEXT(edittmp), TRUE);
                    texttmp = vt_get_selection(((ZvtTerm *)(this_screen->viewport))->vx, &len);
                    if(len > 0)
                        gtk_text_insert(GTK_TEXT(edittmp), NULL, NULL, NULL,
                                        texttmp, len);
                    gtk_editable_copy_clipboard(GTK_EDITABLE(edittmp));
                    gtk_widget_destroy(GTK_WIDGET(edittmp));
#endif
               }
       	}
}

/* These are support routines for gui_file_dialog() */

/* Ripped from functions.c because I couldn't get it to link from there */
char * fencode (unsigned char * input)
{
	char	*result;
	int	i = 0;

	result = (char *)new_malloc(strlen((char *)input) * 2 + 1);
	while (*input)
	{
		result[i++] = (*input >> 4) + 0x41;
		result[i++] = (*input & 0x0f) + 0x41;
		input++;
	}
	result[i] = '\0';

	return result;		/* DONT USE RETURN_STR HERE! */
}

typedef struct _gtkparam {
	GtkWidget	*window;
	Screen		*screen;
	gpointer	data[10];
	} GtkParam;
	
void gtk_file_ok(GtkWidget *widget, GtkParam *param)
{
   char *tmp;

	codeptr = (char *)param->data[0];
        paramptr = m_strdup("OK ");
        tmp = fencode(gtk_file_selection_get_filename(GTK_FILE_SELECTION(param->window)));
	gtk_widget_destroy(GTK_WIDGET(param->window));
        malloc_strcat(&paramptr, tmp);
        new_free(&tmp);
	sendevent(EVFILE, param->screen->current_window->refnum);
	free(param);
}

void gtk_file_cancel(GtkWidget *widget, GtkParam *param)
{
	gtk_widget_destroy(GTK_WIDGET(param->window));
	codeptr = (char *)param->data[0];
        paramptr = m_strdup("CANCEL ");
	sendevent(EVFILE, param->screen->current_window->refnum);
	free(param);
}

void delete(GtkWidget *widget, GtkWidget *event, GtkParam *param)
{
	gtk_widget_destroy(GTK_WIDGET(param->window));
	free(param);
}

void delete2(GtkWidget *widget, GtkParam *param)
{
	gtk_widget_destroy(GTK_WIDGET(param->window));
	free(param);
}

int validatefont(char *font, Screen *screen)
{
    int z, curwidth = -1, curheight = -1;
    GdkFont *curfont;
    
    if(font && *font)
    {
        curfont = gdk_font_load(font);
        for(z=0;z<256;z++)
        {
            if(curwidth == -1)
                curwidth = gdk_char_width(curfont, (char)z);
            else if(curwidth != gdk_char_width(curfont, (char)z))
                return FALSE;
        }
        for(z=0;z<256;z++)
        {
            if(curheight == -1)
                curheight = gdk_char_height(curfont, (char)z);
            else if(curheight != gdk_char_height(curfont, (char)z))
                return FALSE;
        }
        screen->maxfontwidth = curwidth;
        screen->maxfontheight = curheight;
        screen->font = curfont;
        return TRUE;
    }
    return FALSE;
}
                
void font_ok_handler(GtkWidget *widget, GtkParam *param)
{
        gchar *font;
        font = gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(param->window));
        if(validatefont(font, param->screen) == TRUE)
            {
#ifdef BXZVT
            zvt_term_set_font_name((ZvtTerm *)param->screen->viewport, font);
#endif
            sendevent(EVREFRESH, param->screen->current_window->refnum);
            }
        else
            bitchsay("Non-fixed width fonts are not yet supported. %s not loaded.", font);
        gtk_widget_destroy(GTK_WIDGET(param->window));
	free(param);
}

typedef enum _gtkcommandlist {
	GTKNONE,
	GTKFILEDIALOG,
	GTKMENUBAR,
	GTKEXIT,
	GTKSETFOCUS,
	GTKMENUPOPUP,
	GTKNEWWIN,
	GTKTITLE,
	GTKPROP,
	GTKFONT,
	GTKWINKILL,
	GTKSCROLL,
        GTKMSGBOX,
        GTKPASTE
} gtkcommandlist;

void gtk_command_handler(void)
{
char buf[2];

	/* Clear the command */
	read(gtkcommandpipe[0], buf, 1);
	
	switch(gtkcommand.command) 
                {
                /* Paste command */
                case GTKPASTE:
                    gtk_paste((char *)gtkcommand.data[0]);
                    free(gtkcommand.data[0]);
                    break;
		/* File Dialog */
                case GTKFILEDIALOG:
		{
		GtkWidget *filew;
		GtkParam  *param;
		int t;

			filew = gtk_file_selection_new((char *)gtkcommand.data[2]);
	
			param = malloc(sizeof(GtkParam));
			
			param->window = filew;
			param->screen = (Screen *)gtkcommand.data[7];
			param->data[0] = gtkcommand.data[6];
			
			gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filew)->ok_button), "clicked", (GtkSignalFunc) gtk_file_ok, param);
			gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filew)->cancel_button), "clicked", (GtkSignalFunc) gtk_file_cancel, param);
	
			gtk_file_selection_set_filename(GTK_FILE_SELECTION(filew), (char *)gtkcommand.data[1]);
	
			gtk_widget_show(filew);
			for(t=0;t<6;t++)
				new_free(&gtkcommand.data[t]);
		}
		break;
		/* Creates a menubar on a window */
		case GTKMENUBAR:
		{
			if(!my_stricmp((char *)gtkcommand.data[1], "-delete"))
				gtk_widget_destroy(((Screen *)gtkcommand.data[0])->menubar);
			else
				newmenubar((Screen *)gtkcommand.data[0], (MenuStruct *)gtkcommand.data[2]);
			new_free(&gtkcommand.data[1]);
		}
		break;
		/* Exit procedure for gtk thread */
		case GTKEXIT:
			gtk_exit(0);
		break;
		/* Focuses the window passed to it */
                case GTKSETFOCUS:
                    gdk_window_raise(GTK_WIDGET(((Screen *)gtkcommand.data[0])->window)->window);
		break;
		/* Creates a popup context menu */
		case GTKMENUPOPUP:
		{
		MenuStruct *menupopup;

      			if((menupopup=findmenu((char *)gtkcommand.data[0]))!=NULL)
      				gtk_menu_popup(GTK_MENU(newsubmenu(menupopup)), NULL, NULL, NULL, NULL, 0, 0);
		new_free(&gtkcommand.data[0]);
		}
		break;
		/* Creates a new IRC window */
		case GTKNEWWIN:
		gtk_new_window((Screen *)gtkcommand.data[0], (Window *)gtkcommand.data[1]);
		break;
		/* Sets the title bar of the window */
		case GTKTITLE:
		if(((Screen *)gtkcommand.data[0])->window)
			gtk_window_set_title(GTK_WINDOW(((Screen *)gtkcommand.data[0])->window), (char *)gtkcommand.data[1]);
		new_free(&gtkcommand.data[1]);
		break;
		/* Opens a properties notebook for the current window */
		case GTKPROP:
		{
		GtkWidget 	*nbwindow,
				*notebook,
				*frame,
				*label;
		GtkParam	*param;
		char titletext[150];

			nbwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	
			param = malloc(sizeof(GtkParam));
			
			param->window = nbwindow;
			
			gtk_signal_connect(GTK_OBJECT(nbwindow), "delete_event", GTK_SIGNAL_FUNC (delete), param);

			gtk_container_border_width(GTK_CONTAINER(nbwindow), 10);
	
			notebook = gtk_notebook_new();
			gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);
			gtk_container_add(GTK_CONTAINER(nbwindow), notebook);
			gtk_widget_show(notebook);

			/* Sets */
			frame = gtk_frame_new("Page 1 of 5");
			gtk_container_border_width(GTK_CONTAINER(frame), 10);
			gtk_widget_set_usize(frame, 100, 75);
			gtk_widget_show(frame);
	
			/*label = gtk_label_new("Sets");
			gtk_container_add(GTK_CONTAINER(frame), label);
			gtk_widget_show(label);*/
	
			label = gtk_label_new("Sets");
			gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, label);
	
			/* Fsets */
			frame = gtk_frame_new("Page 2 of 5");
			gtk_container_border_width(GTK_CONTAINER(frame), 10);
			gtk_widget_set_usize(frame, 100, 75);
			gtk_widget_show(frame);
	
			/*label = gtk_label_new("Fsets");
			gtk_container_add(GTK_CONTAINER(frame), label);
			gtk_widget_show(label);*/
	
			label = gtk_label_new("Fsets");
			gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, label);
			
			/* Csets */
			frame = gtk_frame_new("Page 3 of 5");
			gtk_container_border_width(GTK_CONTAINER(frame), 10);
			gtk_widget_set_usize(frame, 100, 75);
			gtk_widget_show(frame);
	
			/*label = gtk_label_new("Csets");
			gtk_container_add(GTK_CONTAINER(frame), label);
			gtk_widget_show(label);*/
	
			label = gtk_label_new("Csets");
			gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, label);
			
			/* Wsets */
			frame = gtk_frame_new("Page 4 of 5");
			gtk_container_border_width(GTK_CONTAINER(frame), 10);
			gtk_widget_set_usize(frame, 200, 150);
			gtk_widget_show(frame);
	
			/*label = gtk_label_new("Wsets");
			gtk_container_add(GTK_CONTAINER(frame), label);
			gtk_widget_show(label);*/
	
			label = gtk_label_new("Wsets");
			gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, label);
			
			/* GTK Settings */
			frame = gtk_frame_new("Page 5 of 5");
			gtk_container_border_width(GTK_CONTAINER(frame), 10);
			gtk_widget_set_usize(frame, 100, 75);
			gtk_widget_show(frame);
	
			/*label = gtk_label_new("GTK Settings");
			gtk_container_add(GTK_CONTAINER(frame), label);
			gtk_widget_show(label);*/
	
			label = gtk_label_new("GTK Settings");
			gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, label);
			
			if(current_window->current_channel)
				sprintf(titletext, "gtkBitchX Properties for %s", current_window->current_channel);
			else
				strcpy(titletext, "gtkBitchX Properties");
				
			gtk_window_set_title(GTK_WINDOW(nbwindow), titletext);
			gtk_widget_show(nbwindow);					
		}
                break;
                /* The Font Dialog */
		case GTKFONT:
		{
		GtkWidget 	*fontdialog;
		GtkParam 	*param;
		
		fontdialog = gtk_font_selection_dialog_new("Select Font");
		
		param = malloc(sizeof(GtkParam));
		
		param->window = fontdialog;
		param->screen = (Screen *)gtkcommand.data[0];
		
		gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fontdialog)->ok_button), "clicked", GTK_SIGNAL_FUNC(font_ok_handler), param);
		gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fontdialog)->cancel_button), "clicked", GTK_SIGNAL_FUNC(delete2), param);
		gtk_widget_show(fontdialog);                                            
		}
		break;
		case GTKWINKILL:
			new_close(((Screen *)gtkcommand.data[0])->pipe[0]);
			new_close(((Screen *)gtkcommand.data[0])->pipe[1]);
			gtk_widget_destroy(((Screen *)gtkcommand.data[0])->window);
		break;
                case GTKSCROLL:
                    gtk_adjustment_set_value(((Screen *)gtkcommand.data[0])->adjust, *((int *)gtkcommand.data[1]));
                    free(gtkcommand.data[1]);
		break;
		case GTKMSGBOX:
		{
		GtkWidget 	*dialog,
				*button,
				*label;
		GtkParam 	*param;
		
		dialog = gtk_dialog_new();
		
		param = malloc(sizeof(GtkParam));
		
		param->window = dialog;

		gtk_window_set_title(GTK_WINDOW(dialog), "gtkBitchX");
		
		button = gtk_button_new_with_label("Ok");
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), button, TRUE, TRUE, 0);
		gtk_widget_show(button);
		
		gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(delete2), param);
		gtk_signal_connect(GTK_OBJECT(dialog), "delete_event", GTK_SIGNAL_FUNC(delete), param);
		
		label = gtk_label_new((char *)gtkcommand.data[0]);
		gtk_container_set_border_width(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), 20);
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
		gtk_widget_show(label);
		
		gtk_widget_show(dialog);
		
		new_free(&gtkcommand.data[0]);
		}
		break;
		}
gtkcommand.command = GTKNONE;
gtkincommand = FALSE;
}

/* Initialize all needed structures, create the main window, 
   start the gtk_thread and gtk handler */
                                         
void gui_init(void)
{
	int z;
	char tbuf[200];
	GtkStyle *style;
#ifndef BXZVT
	GdkPixmap *pixmap;
	GdkBitmap *mask;
#endif
	GdkColormap *cmap;
	GtkWidget *tmpbox;
	
	TI_cols = 80;
	TI_lines = 25;
	li = TI_lines;
	co = TI_cols;
	
	/* Initialize threads support */
	if(g_thread_supported())
		{
		printf("gtkBitchX panic! Could not initialize threads!\n");
		exit(500);
		}
	
	g_thread_init(NULL);
	
	pthread_mutex_init(&evmutex, NULL);
	
        /* Open the IPC pipes */
        pipe(gtkipcin);
	pipe(gtkcommandpipe);
	pipe(mainpipe);
	
        /* Load the default font */
	mainfont = gdk_font_load("vga");
	
        /* Create the main window */
	mainwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);

        /* Attach handlers to the events */
	gtk_signal_connect(GTK_OBJECT(mainwindow), "delete_event", GTK_SIGNAL_FUNC(window_destroy), NULL);
	gtk_signal_connect(GTK_OBJECT(mainwindow), "destroy", GTK_SIGNAL_FUNC(destroy), NULL);
	gtk_signal_connect(GTK_OBJECT(mainwindow), "key_press_event", GTK_SIGNAL_FUNC(gtk_keypress), NULL);
	gtk_signal_connect(GTK_OBJECT(mainwindow), "size_allocate", GTK_SIGNAL_FUNC(gtk_windowsize), NULL);
	gtk_signal_connect(GTK_OBJECT(mainwindow), "focus_in_event", GTK_SIGNAL_FUNC(gtk_windowfocus), NULL);
	
	gtk_container_set_border_width(GTK_CONTAINER(mainwindow), 0);
	
	tmpbox = gtk_hbox_new(FALSE, 0);
	mainbox = gtk_vbox_new(FALSE, 0);
	
	style = gtk_style_new();

#ifdef BXZVT
	mainviewport = (GtkWidget *)zvt_term_new();
	zvt_term_set_size((ZvtTerm *)mainviewport, 80, 25);
	zvt_term_set_font_name((ZvtTerm *)mainviewport, "vga");
	zvt_term_set_scrollback((ZvtTerm *)mainviewport, 0);
	zvt_term_set_blink((ZvtTerm *)mainviewport, TRUE);
	zvt_term_set_bell((ZvtTerm *)mainviewport, TRUE);
#else	
	mainviewport = gtk_text_new(0, 0);
#endif
		
	gtk_signal_connect(GTK_OBJECT(mainviewport), "button_press_event", GTK_SIGNAL_FUNC(gtk_contextmenu), (gpointer)mainwindow);

	/* Add BitchX colors to the system colormap */
	cmap = gdk_colormap_get_system();
	for(z=0;z<16;z++)
		gdk_color_alloc(cmap, &colors[z]);
	
#ifndef BXZVT
	memcpy(style, gtk_widget_get_style(GTK_WIDGET(mainviewport)), sizeof(GtkStyle));
	memcpy(style->base, &colors[BLACK], sizeof(GdkColor));
	memcpy(style->bg, &colors[BLACK], sizeof(GdkColor));
	memcpy(style->fg, &colors[WHITE], sizeof(GdkColor));
#endif

        /* Use a background XPM if it exists */
	sprintf(tbuf, "%s/bitchx.xpm", DEFAULT_CTOOLZ_DIR);
	if(access(tbuf, R_OK) == 0)
	        {
#ifdef BXZVT
	        zvt_term_set_background((ZvtTerm *)mainviewport, tbuf, FALSE, FALSE);
#else
 		pixmap = gdk_pixmap_create_from_xpm(mainwindow->window, &mask,
 			&style->bg[GTK_STATE_NORMAL], tbuf);
		if(pixmap) style->bg_pixmap[0] = pixmap;
#endif
 		}
#ifdef BXZVT
        else
     	        zvt_term_set_background((ZvtTerm *)mainviewport, 0, FALSE, FALSE);
#else
 	gtk_widget_set_style(mainviewport, style);
#endif
 	
        /* Make the window view port readonly and nonwrapping */
#ifndef BXZVT
 	gtk_text_set_editable(GTK_TEXT(mainviewport), FALSE);
 	gtk_text_set_word_wrap(GTK_TEXT(mainviewport), FALSE);
#endif
 
        /* Create the vertical scroll bar */
        mainadjust = (GtkAdjustment *)gtk_adjustment_new(get_int_var(SCROLLBACK_VAR), 0, get_int_var(SCROLLBACK_VAR), 1, 22, 22);
 	mainscroller = gtk_vscrollbar_new(mainadjust);
	GTK_WIDGET_UNSET_FLAGS(mainscroller, GTK_CAN_FOCUS);
        
        gtk_signal_connect(GTK_OBJECT(mainadjust), "value_changed", GTK_SIGNAL_FUNC(gtk_scrollerchanged), mainwindow);
        
        /* Add to the layout */
	gtk_container_add(GTK_CONTAINER(mainwindow), mainbox);
	
	gtk_box_pack_start(GTK_BOX(tmpbox), GTK_WIDGET(mainviewport), TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(tmpbox), mainscroller, FALSE, TRUE, 0);
	
	gtk_box_pack_end(GTK_BOX(mainbox), tmpbox, TRUE, TRUE, 0);
	
	/* Show the widgets */
	gtk_widget_show(GTK_WIDGET(mainviewport));
	gtk_widget_show(mainscroller);
	gtk_widget_show(mainbox);
	gtk_widget_show(tmpbox);
	gtk_widget_show(mainwindow);

#ifdef BXZVT        
	zvt_term_set_color_scheme((ZvtTerm *)mainviewport, bx_red, bx_green, bx_blue);
#endif

	/* Add to the gtk IO event list */
	gdk_input_add(mainpipe[0], GDK_INPUT_READ, (GdkInputFunction)output_info, (gpointer)NULL);
	gdk_input_add(gtkcommandpipe[0], GDK_INPUT_READ, (GdkInputFunction)gtk_command_handler, (gpointer)NULL);
	
        lastclicklinedata = new_malloc(1000);
        
	if(pthread_create(&gtkthread, NULL, (void *)&gtk_main, NULL))
		{
	    	printf("gtkBitchX panic! Could not create gtk thread!\n");
	    	exit(500);
	    	}
	
	/* Pause for the gtk thread to startup. */
	/* usleep(1000); */
}

/* Handler for menuitem events */
void menuitemhandler(gpointer *data)
{
menucmd = (int) *data;

   sendevent(EVMENU, last_input_screen->current_window->refnum);
}

void removetilde(char *dest, char *src)
{
	int z, cur=0;

	for(z=0;z<strlen(src);z++)
		{
		if(src[z] != '~')
			{
			dest[cur] = src[z];
			cur++;
			}
		}
	dest[cur] = 0;
}

/* Create a submenu, used in menubar and popup menu creation */
GtkWidget *newsubmenu(MenuStruct *menutoadd)
{
GtkWidget 	*tmphandle,
		*tmpmenu;
MenuList *tmp;
char expbuf[500];

	tmp = menutoadd->menuorigin;
	
	tmpmenu = gtk_menu_new();
	
	while(tmp!=NULL)
		{
		if(tmp->menutype == GUISEPARATOR)
			tmphandle=gtk_menu_item_new();
		else
			{
			removetilde(expbuf, tmp->name);
			tmphandle=gtk_menu_item_new_with_label(expbuf);
			}
		if(tmp->menutype==GUISUBMENU || tmp->menutype==GUISHARED || tmp->menutype==GUIBRKSUBMENU)
			gtk_menu_item_set_submenu(GTK_MENU_ITEM(tmphandle), newsubmenu((MenuStruct *)findmenu(tmp->submenu)));
		if(tmp->menutype == GUIMENUITEM)
			gtk_signal_connect_object(GTK_OBJECT(tmphandle), "activate", GTK_SIGNAL_FUNC(menuitemhandler), (gpointer) &tmp->menuid);
		gtk_menu_append(GTK_MENU(tmpmenu), tmphandle);
		gtk_widget_show(tmphandle);
		tmp=tmp->next;
		}
		
	gtk_widget_show(tmpmenu);				
	return tmpmenu;
}

/* Creates a menubar on a given window/screen */
void newmenubar(Screen *menuscreen, MenuStruct *menutoadd)
{
GtkWidget *tmphandle;
MenuList *tmp;
char expbuf[500];

        if(!menutoadd || !menutoadd->menuorigin)
        	{
                say("Cannot create blank menu.");
                return;
                }
	tmp = menutoadd->menuorigin;
      	if(menuscreen->menubar)
      		gtk_widget_destroy(menuscreen->menubar);
      	menuscreen->menubar = gtk_menu_bar_new();
      	while(tmp!=NULL)
      		{
      		if(tmp->menutype == GUISEPARATOR)
      			tmphandle = gtk_menu_item_new();
      		else
      			{
      			removetilde(expbuf, tmp->name);
     			tmphandle = gtk_menu_item_new_with_label(expbuf);
     			}
          	if(tmp->menutype==GUISUBMENU || tmp->menutype==GUISHARED || tmp->menutype==GUIBRKSUBMENU)
          		gtk_menu_item_set_submenu(GTK_MENU_ITEM(tmphandle), newsubmenu((MenuStruct *)findmenu(tmp->submenu)));
       		if(tmp->menutype == GUIMENUITEM)
    			gtk_signal_connect_object(GTK_OBJECT(tmphandle), "activate", GTK_SIGNAL_FUNC(menuitemhandler), (gpointer) &tmp->menuid);
        	gtk_menu_bar_append(GTK_MENU_BAR(menuscreen->menubar), tmphandle);
        	gtk_widget_show(tmphandle);
        	tmp=tmp->next;
          	}
    	gtk_box_pack_end(GTK_BOX(menuscreen->box), menuscreen->menubar, FALSE, TRUE, 0);
    	gtk_widget_show(menuscreen->menubar);
	gtk_sizewindow(menuscreen);
}

/* This section is for portability considerations */
void gui_clreol(void)
{
	gtkprintf(TI_el);
}

void gui_gotoxy(int col, int row)
{
	col++;row++;
	gtkprintf("\e[%d;%dH", row, col);
}

void gui_clrscr(void)
{
Screen *tmp;

   for(tmp = screen_list; tmp; tmp = tmp->next)
	{
	if(tmp->pipe[1])
		write(tmp->pipe[1], "\e[2J", 3);
	}
}

void gui_left(int num)
{
#ifdef BXZVT
   gtkprintf("\e[D");
#else
   gtk_backward(num);
#endif
}

void gui_right(int num)
{
#ifdef BXZVT
   gtkprintf("\e[C");
#else
   gtk_forward(num);
#endif
}

void gui_scroll(int top, int bot, int n)
{
#ifndef BXZVT
	gtkprintf("\e[%d;%d;%dN", top, bot, n);
#else
      /* Stolen from term.c */
      int i,oneshot=0,rn,sr,er;
      char thing[128], final[128], start[128];
        
      /* Some basic sanity checks */
      if (n == 0 || top == bot || bot < top)
      	return;
                                
      sr = er = 0;
      final[0] = start[0] = thing[0] = 0;
                                                
      if (n < 0)
      	rn = -n;
      else
      	rn = n;

	if (TI_csr && (TI_ri || TI_rin) && (TI_ind || TI_indn))
	{
		/*
		 * Previously there was a test to see if the entire scrolling
		 * region was the full screen.  That test *always* fails,
		 * because we never scroll the bottom line of the screen.
		 */
		strcpy(start, (char *)tparm(TI_csr, top, bot));
		strcpy(final, (char *)tparm(TI_csr, 0, TI_lines-1));

		if (n > 0)
		{
			sr = bot;
			er = top;
			strcpy(thing, TI_ind);
		}
		else
		{
			sr = top;
			er = bot;
			strcpy (thing, TI_ri);
		}
	}

	if (!thing[0])
		return;

	/* Do the actual work here */
	if (start[0])
		gtkprintf(start);
	
	gui_gotoxy (0, sr);

	if (oneshot)
		gtkprintf(thing);
	else
	{
		for (i = 0; i < rn; i++)
			gtkprintf(thing);
	}
	gui_gotoxy (0, er);
	if (final[0])
		gtkprintf(final);
                                                                                                            
#endif
}

void gui_flush(void)
{

}

void gui_puts(char *buffer)
{
int i;
	for (i = 0; i < strlen(buffer); i++) 
		gtkputc(buffer[i]);
	gtkputc('\n'); 
}

/* Create a new (non-main) window */
void gui_new_window(Screen *new, Window *win)
{
gtkcommand.command = GTKNEWWIN;
gtkcommand.data[0] = (gpointer) new;
gtkcommand.data[1] = (gpointer) win;
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
gtk_wait_command();
}

void gtk_new_window(Screen *new, Window *win)
{
char *defmenu, *deffont;
GtkWidget *tmpbox;
GtkStyle *style;
#ifndef BXZVT
GdkPixmap *pixmap;
GdkBitmap *mask;
#endif
MenuStruct *tmpms;
char tbuf[200];

        deffont=get_string_var(DEFAULT_FONT_VAR);
        if(deffont && *deffont)
        	new->font = gdk_font_load(deffont);
        else 
        	new->font = gdk_font_load("vga");

        /* Create the main window */
	new->window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	/* Open the screen's output pipe */
	pipe(new->pipe);
	
        /* Attach handlers to the events */
	gtk_signal_connect(GTK_OBJECT(new->window), "delete_event", GTK_SIGNAL_FUNC(window_destroy), NULL);
	gtk_signal_connect(GTK_OBJECT(new->window), "destroy", GTK_SIGNAL_FUNC(destroy), NULL);
	gtk_signal_connect(GTK_OBJECT(new->window), "key_press_event", GTK_SIGNAL_FUNC(gtk_keypress), NULL);
	gtk_signal_connect(GTK_OBJECT(new->window), "size_allocate", GTK_SIGNAL_FUNC(gtk_windowsize), NULL);
	gtk_signal_connect(GTK_OBJECT(new->window), "focus_in_event", GTK_SIGNAL_FUNC(gtk_windowfocus), NULL);
	
	gtk_container_set_border_width(GTK_CONTAINER(new->window), 0);
	
	tmpbox = gtk_hbox_new(FALSE, 0);
	new->box = gtk_vbox_new(FALSE, 0);
	
	style = gtk_style_new();

#ifdef BXZVT
	new->viewport = (GtkWidget *)zvt_term_new();
	if(deffont && *deffont)
		zvt_term_set_font_name((ZvtTerm *)new->viewport, deffont);
	else
		zvt_term_set_font_name((ZvtTerm *)new->viewport, "vga");
	zvt_term_set_size((ZvtTerm *)new->viewport, 80, 25);
	zvt_term_set_scrollback((ZvtTerm *)new->viewport, 0);
	zvt_term_set_blink((ZvtTerm *)new->viewport, TRUE);
	zvt_term_set_bell((ZvtTerm *)new->viewport, TRUE);
#else	
	new->viewport = gtk_text_new(0, 0);
#endif
	
	gtk_signal_connect(GTK_OBJECT(new->viewport), "button_press_event", GTK_SIGNAL_FUNC(gtk_contextmenu), new->window);

#ifndef BXZVT
	memcpy(style, gtk_widget_get_style(GTK_WIDGET(new->viewport)), sizeof(GtkStyle));
	memcpy(style->base, &colors[BLACK], sizeof(GdkColor));
	memcpy(style->bg, &colors[BLACK], sizeof(GdkColor));
	memcpy(style->fg, &colors[WHITE], sizeof(GdkColor));
#endif
            
        /* Use a background XPM if it exists */	
        sprintf(tbuf, "%s/bitchx.xpm", DEFAULT_CTOOLZ_DIR);
	if(access(tbuf, R_OK) == 0)
	        {
#ifdef BXZVT
	        zvt_term_set_background((ZvtTerm *)new->viewport, tbuf, FALSE, FALSE);
#else
 		pixmap = gdk_pixmap_create_from_xpm(new->window->window, &mask,
 			&style->bg[GTK_STATE_NORMAL], tbuf);
		if(pixmap) style->bg_pixmap[0] = pixmap;
#endif
 		}
#ifdef BXZVT
        else
     	        zvt_term_set_background((ZvtTerm *)new->viewport, 0, FALSE, FALSE);
#else
 	gtk_widget_set_style(new->viewport, style);
#endif
 	
        /* Make the window view port readonly and nonwrapping */
 #ifndef BXZVT
 	gtk_text_set_editable(GTK_TEXT(new->viewport), FALSE);
 	gtk_text_set_word_wrap(GTK_TEXT(new->viewport), FALSE);
 #endif
 	
        /* Create the vertical scroll bar */
        new->adjust = (GtkAdjustment *)gtk_adjustment_new(get_int_var(SCROLLBACK_VAR), 0, get_int_var(SCROLLBACK_VAR), 1, 22, 22);
 	new->scroller = gtk_vscrollbar_new(new->adjust);
	GTK_WIDGET_UNSET_FLAGS(new->scroller, GTK_CAN_FOCUS);
        
   	gtk_signal_connect(GTK_OBJECT(new->adjust), "value_changed", GTK_SIGNAL_FUNC(gtk_scrollerchanged), (gpointer)new->window);
        
        /* Add to the layout */
	gtk_container_add(GTK_CONTAINER(new->window), new->box);
	
	gtk_box_pack_start(GTK_BOX(tmpbox), new->viewport, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(tmpbox), new->scroller, FALSE, TRUE, 0);
	
	gtk_box_pack_end(GTK_BOX(new->box), tmpbox, TRUE, TRUE, 0);

	gtk_widget_show(GTK_WIDGET(new->viewport));
	gtk_widget_show(new->scroller);
	gtk_widget_show(new->box);
	gtk_widget_show(tmpbox);
	gtk_widget_show(new->window);

#ifdef BXZVT
	zvt_term_set_color_scheme((ZvtTerm *)new->viewport, bx_red, bx_green, bx_blue);
#endif
	
	/* Add to the gtk IO event list */
	gdk_input_add(new->pipe[0], GDK_INPUT_READ, (GdkInputFunction)output_info, (gpointer)NULL);
	
	defmenu=get_string_var(DEFAULT_MENU_VAR);
	if(defmenu && *defmenu)
		{
		if((tmpms = (MenuStruct *)findmenu(defmenu))!=NULL)
			newmenubar(new, tmpms);
		}                                                                         

	gtk_maxfont(new);
	gtk_sizewindow(new);
}
                                  
void gui_kill_window(Screen *killscreen)
{
if(gtkthreadkill == TRUE)
	{
	new_close(killscreen->pipe[0]);
	new_close(killscreen->pipe[1]);
	gtk_widget_destroy(killscreen->window);
	printf("Widget Destroyed\n");
	}
else
	{
	gtk_wait_command();
	gtkcommand.command = GTKWINKILL;
	gtkcommand.data[0] = (gpointer) killscreen;
	gtkincommand = TRUE;
	write(gtkcommandpipe[1], "A", 1);
	gtk_wait_command();
	}
}

int gui_read(Screen *screen, char *buffer, int maxbufsize)
{
        return read(gtkipcin[0], buffer, maxbufsize);
}

void gui_settitle(char *titletext, Screen *gtkwin)
{
gtk_wait_command();
gtkcommand.command = GTKTITLE;
gtkcommand.data[1] = (gpointer) m_strdup(titletext);
gtkcommand.data[0] = (gpointer) gtkwin;
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
}

void gui_msgbox(void)
{
extern char *msgtext;

gtk_wait_command();
gtkcommand.command = GTKMSGBOX;
gtkcommand.data[0] = (gpointer) msgtext;
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
}

void gui_popupmenu(char *menuname)
{
gtk_wait_command();
gtkcommand.command = GTKMENUPOPUP;
gtkcommand.data[0] = (gpointer) m_strdup(menuname);
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
}

void gui_font_dialog(Screen *screen)
{
gtk_wait_command();
gtkcommand.command = GTKFONT;
gtkcommand.data[0] = (gpointer) screen;
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
}


void gui_file_dialog(char *type, char *path, char *title, char *ok, char *apply, char *code, char *szButton)
{
gtk_wait_command();
gtkcommand.command = GTKFILEDIALOG;
gtkcommand.data[0] = (gpointer) m_strdup(type);
gtkcommand.data[1] = (gpointer) m_strdup(path);
gtkcommand.data[2] = (gpointer) m_strdup(title);
gtkcommand.data[3] = (gpointer) m_strdup(ok);
gtkcommand.data[4] = (gpointer) m_strdup(apply);
gtkcommand.data[5] = (gpointer) m_strdup(szButton);
gtkcommand.data[6] = (gpointer) m_strdup(code);
gtkcommand.data[7] = (gpointer) current_window->screen;
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
}

void gui_properties_notebook(void)
{
gtk_wait_command();
gtkcommand.command = GTKPROP;
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
}

#define current_screen      last_input_screen
#define INPUT_BUFFER        current_screen->input_buffer
#define ADD_TO_INPUT(x)     strmcat(INPUT_BUFFER, (x), INPUT_BUFFER_SIZE);

void gtk_paste(char *args)
{
 GtkWidget *edittmp;
 char   *oclip, *clip, *bit;
 int    line = 0, i = 0;
 char   *channel = NULL;
 int topic = 0;
 int smartpaste = 0;
 char smart[512]; /* SmartPaste buffer (256) */
 int smartsize = 80;
 int input_line = 0;

 /* Parse arguments */
 if (!args || !*args)
     channel = get_current_channel_by_refnum(0);
 else
 {
     char *t;
     while (args && *args)
     {
         t = next_arg(args, &args);
         if (*t == '-')
         {
          if (!my_strnicmp(t, "-topic", strlen(t)))
          {
              topic = 1;
          }
          else if (!my_strnicmp(t, "-smart", strlen(t)))
          {
              /* Smartpaste */
              smartpaste = 1;
          }
          else if (!my_strnicmp(t, "-input", strlen(t)))
          {
              /* Smartpaste */
              input_line = 1;
          }
         }
         else
             channel = t;
     }
 }
 if (!channel)
  channel = get_current_channel_by_refnum(0);

  edittmp = gtk_text_new(NULL, NULL);
  gtk_text_set_editable(GTK_TEXT(edittmp), TRUE);
  gtk_editable_paste_clipboard(GTK_EDITABLE(edittmp));
  oclip = gtk_editable_get_chars(GTK_EDITABLE(edittmp), 0, -1); line = 0;
  gtk_widget_destroy(GTK_WIDGET(edittmp));

  if(!oclip)
      return;

  oclip = clip = strdup(oclip);
  
  if(strlen(oclip) < 1)
  {
      free(oclip);
      return;
  }
          

   if (!smartpaste)
    {
     /* Ordinary paste */
     clip = oclip; bit = strtok(clip, "\n\r");
     while (bit)
      {
       if (input_line)
        {
         ADD_TO_INPUT(bit);
         update_input(UPDATE_FROM_CURSOR);
        } else
         if (!topic)
          {
           if (do_hook(PASTE_LIST, "%s %s", channel, bit))
             send_text(channel, bit, NULL, 1, 0);
          } else
           {
            send_to_server("TOPIC %s :%s", channel, bit);
            break;
           }
       line++;
       bit = strtok(NULL, "\n\r");
       if (input_line && bit)
         send_line(0, NULL);

      }
    } else
     {
      /* Rosmo's Incredibly Dull SmartPaste:
         Fits as much as possible into a 80-nick_length buffer, stripping
         spaces from beginning and end and then pasting */

      if (!topic)
        smartsize = 512;
       else
        smartsize = 128; /* 'tis correct? */

      clip = oclip;
      while (*clip && *clip == ' ') clip++; /* Strip spaces from the start */

      *smart = '\0';
      while (*clip)
       {
        if (input_line && *smart)
          send_line(0, NULL);

        *smart = '\0';

        i = 0;
        while (*clip && i < smartsize)
         {
          if (*clip != '\n')
           {
            if (*clip != '\r') strncat(smart, clip, 1);
           }
           else
            {
             strcat(smart, " "); clip++; i++;
             while (*clip && *clip == ' ') clip++; /* Strip spaces */
             clip--;
            }
          clip++; i++;
         }

       if (strcmp(smart, "") != 0) /* If our smart buffer has stuff, send it! */
         {
          if (input_line)
           {
            ADD_TO_INPUT(smart);
            update_input(UPDATE_FROM_CURSOR);
           } else
            if (!topic)
             {
              if (do_hook(PASTE_LIST, "%s %s", channel, smart))
               send_text(channel, smart, NULL, 1, 0);
             }
             else
              {
               send_to_server("TOPIC %s :%s", channel, smart);
               break;
              }
         }
       }


   free(oclip); /* Free */
  }
}

void gui_paste(char *args)
{
    gtk_wait_command();
    gtkcommand.command = GTKPASTE;
    gtkcommand.data[0] = (gpointer) strdup(args);
    gtkincommand = TRUE;
    write(gtkcommandpipe[1], "A", 1);
    gtk_wait_command();
}

void gui_setfocus(Screen *screen)
{
gtk_wait_command();
gtkcommand.command = GTKSETFOCUS;
gtkcommand.data[0] = (gpointer) screen;
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
gtk_wait_command();
}

void gui_scrollerchanged(Screen *screen, int position)
{
int *pos;

pos = malloc(sizeof(int));
*pos = position;

gtk_wait_command();
gtkcommand.command = GTKSCROLL;
gtkcommand.data[0] = (gpointer) screen;
gtkcommand.data[1] = (gpointer) pos;
write(gtkcommandpipe[1], "A", 1);
gtk_wait_command();
}

void gui_query_window_info(Screen *screen, char *fontinfo, int *x, int *y, int *cx, int *cy)
{
        *x = *y = *cx = *cy = 0;
        strcpy(fontinfo, "unknown");
}

void gui_play_sound(char *filename)
{

}

int gui_send_mci_string(char *mcistring, char *retstring)
{
return 0;
}

void gui_get_sound_error(int errnum, char *errstring)
{

}

void gui_menu(Screen *screen, char *addmenu)
{
MenuStruct *menutoadd;
if((menutoadd = findmenu(addmenu)) == NULL)
	{
	say("Menu %s not found!", addmenu);
	return;
	}
gtk_wait_command();
gtkcommand.command = GTKMENUBAR;
gtkcommand.data[0] = (gpointer) screen;
gtkcommand.data[1] = (gpointer) m_strdup(addmenu);
gtkcommand.data[2] = (gpointer) menutoadd;
gtkincommand = TRUE;
write(gtkcommandpipe[1], "A", 1);
}

int gui_isset(Screen *screen, fd_set *rd, int what)
{
	if(screen == last_input_screen)
		return FD_ISSET(gtkipcin[0], rd);
	else
		return FALSE;
}

int gui_putc(int c)
{
   return gtkputc(c);
}

void gui_exit(void)
{
if(gtkthreadkill == TRUE)
	gtk_exit(0);
else
	{
	gtkcommand.command = GTKEXIT;
	gtkincommand = TRUE;
	write(gtkcommandpipe[1], "A", 1);
	gtk_wait_command();
	}
}

void gui_screen(Screen *new)
{
	new->old_li=new->li;
	new->old_co=new->co;
	new->window = mainwindow;
	new->viewport = mainviewport;
	new->menubar = mainmenubar;
	new->scroller = mainscroller;
	new->box = mainbox;
	new->adjust = mainadjust;
	new->font = mainfont;
	new->gtkio = gtkio;
	new->pipe[0] = mainpipe[0];
	new->pipe[1] = mainpipe[1];
#ifndef BXZVT
	new->fg = WHITE;
	new->bg = BLACK;
#endif		
	main_screen = new;
	gtk_maxfont(new);
	gtk_sizewindow(new);
}

void gui_resize(Screen *new)
{
	gtk_resize(new);
}
